#ifndef CLICK_PRINTRATE_HH
#define CLICK_PRINTRATE_HH
#include <click/element.hh>
#include <click/string.hh>
CLICK_DECLS

/*
 * =c
 * PrintRate([TAG] [, KEYWORDS])
 * =s debugging
 * =d
 * Assumes input packets are Wifi packets (ie a wifi_pkt struct from 
 * wifi.hh). Prints out a description of those packets.
 *
 * Keyword arguments are:
 *
 * =over 8
 *
 * =a
 * Print, Wifi
 */

class PrintRate : public Element {
 public:
  
  PrintRate();
  ~PrintRate();
  
  const char *class_name() const		{ return "PrintRate"; }
  const char *port_count() const		{ return PORTS_1_1; }
  const char *processing() const		{ return AGNOSTIC; }
  
  int configure(Vector<String> &, ErrorHandler *);
  Packet *simple_action(Packet *);
  void add_handlers();

  bool _print;
  int _rate;
};

CLICK_ENDDECLS
#endif
